/* 
 * Copyright (C) 2004 Romain Dolbeau <romain@dolbeau.org>
 *
 *  This file is subject to the terms and conditions of the GNU General Public
 *  License. See the file COPYING in the main directory of this archive for
 *  more details.
 */

package lavcGenetic;

import java.util.*;
import javax.swing.*;
import java.awt.event.*;

class lavcAllStatisticsDisplay extends JPanel {
    private JFrame parent;
    private lavcOptionDisplayersPanel lodp;
    private JTextArea lBest;
    private JTextArea lFastest;

    lavcAllStatisticsDisplay(Set allOptions, JFrame p) {
        parent = p;
        lodp = new lavcOptionDisplayersPanel(allOptions);

        lBest = new JTextArea("");
        lBest.setLineWrap(true);
        lBest.setWrapStyleWord(true);
        lBest.setEditable(false);

        lFastest = new JTextArea("");
        lFastest.setLineWrap(true);
        lFastest.setWrapStyleWord(true);
        lFastest.setEditable(false);
        
        final Box box = Box.createVerticalBox();
        add(box);
        box.add(lodp);
        box.add(lBest);
        box.add(lFastest);
    }

    void refresh(lavcResultsPool lrp,
                 lavcOptionList best,
                 int step,
                 int bestStep,
                 lavcOptionList fastest,
                 double p) {
        boolean improved = (step != bestStep);
        lodp.updateAllDisplayers(lrp);
        lBest.setText("Best so far (" + step + "):\n\t" + best.toPrettyString() + "\n\t-> " + lrp.getResult(best) +
                      (improved ? "(IMPROVED)" : ("(from step" + bestStep + ")")));
        lFastest.setText("Fastest within " + p + " percent (" + step + "):\n\t" + fastest.toPrettyString() + "\n\t-> " + lrp.getResult(fastest));
        
        parent.pack();
        parent.repaint();
    }
}
