/* 
 * Copyright (C) 2004 Romain Dolbeau <romain@dolbeau.org>
 *
 *  This file is subject to the terms and conditions of the GNU General Public
 *  License. See the file COPYING in the main directory of this archive for
 *  more details.
 */

package lavcGenetic;

import java.util.*;

class lavcJobDist {
    private List allMachines;
    
    lavcJobDist(List am) {
        allMachines = Collections.synchronizedList(new ArrayList(am));
    }

    String getMachine() {
        String temp = null;

        while (temp == null) {
            synchronized(allMachines) {
                if (allMachines.size() > 0) {
                    temp = (String)allMachines.get(0);
                    allMachines.remove(temp);
                }                
            }
            if (temp == null) {
                try {
                    synchronized (this) {
                        this.wait(60);
                    }
                } catch (Exception e) { }
            }
        }
        
        return temp;
    }

    void returnMachine(String m) {
        synchronized(allMachines) {
            allMachines.add(m);
        }
    }
}
