/* 
 * Copyright (C) 2004 Romain Dolbeau <romain@dolbeau.org>
 *
 *  This file is subject to the terms and conditions of the GNU General Public
 *  License. See the file COPYING in the main directory of this archive for
 *  more details.
 */

package lavcGenetic;

import java.util.*;
import java.rmi.*;

class lavcMencoderWrapperRemote implements lavcMencoderWrapper {

    String machine;
    lavcMencoderWrapper service = null;

    lavcMencoderWrapperRemote(String m) {
        super();
        machine = m;

        if (System.getSecurityManager() == null) {
            System.setSecurityManager(new RMISecurityManager());
        }
        try {
            service = (lavcMencoderWrapper)Naming.lookup("rmi://" + machine + "/lavcMencoderWrapperRemoteService");
        } catch (Exception e) { lavcGeneticMain.err_println("lavcMencoderWrapperRemote: " + e); }
    }

    public lavcResults dumpMoviePassX(lavcEncodeData led , int pass, int bitrate, String machine)  throws RemoteException {
        if (service == null) {
            return null;
        }
        return service.dumpMoviePassX(led, pass, bitrate, machine);
    }
}
