/* 
 * Copyright (C) 2004 Romain Dolbeau <romain@dolbeau.org>
 *
 *  This file is subject to the terms and conditions of the GNU General Public
 *  License. See the file COPYING in the main directory of this archive for
 *  more details.
 */

package lavcGenetic;

import java.util.*;
import java.rmi.*;
import java.rmi.server.*;

class lavcMencoderWrapperRemoteService extends UnicastRemoteObject implements lavcMencoderWrapper {
    lavcMencoderWrapper lmw;

    lavcMencoderWrapperRemoteService() throws RemoteException {
        super();
        lmw = new lavcMencoderWrapperLocal(lavcGeneticMain.kTimeLimit);
    }

    public static void main(String arg[])
    {
        if (System.getSecurityManager() == null)
            System.setSecurityManager(new RMISecurityManager());
        try {
            lavcMencoderWrapperRemoteService svr = new lavcMencoderWrapperRemoteService();
            //System.out.println("Trying to bind lavcMencoderWrapper on " + System.getProperty("java.rmi.server.hostname") + "...");
            Naming.rebind("lavcMencoderWrapperRemoteService", svr);
            
            System.out.println("lavcMencoderWrapper bound on " + System.getProperty("java.rmi.server.hostname"));
        } catch (Exception e) { System.err.println("lavcMencoderWrapperRemoteService: " + e); }
    }

    public lavcResults dumpMoviePassX(lavcEncodeData led , int pass, int bitrate, String machine) throws RemoteException {
        if (lmw == null)
            return null;
        return lmw.dumpMoviePassX(led, pass, bitrate, machine);
    }
}
