/* 
 * Copyright (C) 2004 Romain Dolbeau <romain@dolbeau.org>
 *
 *  This file is subject to the terms and conditions of the GNU General Public
 *  License. See the file COPYING in the main directory of this archive for
 *  more details.
 */

package lavcGenetic;

import java.util.*;
import javax.swing.*;
import java.awt.event.*;
import org.jfree.chart.*;
import org.jfree.data.*;
import org.jfree.chart.plot.PiePlot;
import java.awt.Color;
import java.awt.Font;

class lavcOptionDisplayer extends JPanel {
    private final lavcOption myOption;
    private JFreeChart chart = null;
    private ChartPanel chartPanel = null;
    private DefaultPieDataset dataset = null;

    private JFreeChart createOptionPieChart(PieDataset dataset, String d) {
        final JFreeChart chart = ChartFactory.createPieChart(d, dataset, false, false, false);
        final PiePlot plot = (PiePlot) chart.getPlot();
        plot.setLabelFont(new Font("SansSerif", Font.PLAIN, 12));
        plot.setNoDataMessage("No data available");
        plot.setCircular(false);
        plot.setLabelLinkPaint(Color.red);
        plot.setLabelGap(0.02);
        return chart;
    }
    
    lavcOptionDisplayer(lavcOption m) {
        myOption = m;
    }

    void buildPieChart(Map statMap) {
        if (chartPanel != null)
            remove(chartPanel);
        dataset = new DefaultPieDataset();
        List l = myOption.getAllVariants();

        Iterator it = l.iterator();
        while (it.hasNext()) {
            lavcOptionInstance loi = (lavcOptionInstance)it.next();
            Integer i = (Integer)statMap.get(loi);
            dataset.setValue(loi, i);
        }
        chart = createOptionPieChart(dataset, myOption.getDescription());
        chartPanel = new ChartPanel(chart);
        chartPanel.setPreferredSize(new java.awt.Dimension(250, 180));
        add(chartPanel);
    }
}
