/* 
 * Copyright (C) 2004 Romain Dolbeau <romain@dolbeau.org>
 *
 *  This file is subject to the terms and conditions of the GNU General Public
 *  License. See the file COPYING in the main directory of this archive for
 *  more details.
 */

package lavcGenetic;

import java.util.*;
import javax.swing.*;
import java.awt.event.*;

class lavcOptionDisplayersPanel extends JPanel {
    private Set allPanels = new HashSet();
    
    lavcOptionDisplayersPanel(Set allOptions) {
        setLayout(new java.awt.GridLayout(0,4));
        Iterator it = allOptions.iterator();
        while(it.hasNext()) {
            lavcOption opt = (lavcOption)it.next();
            if (opt.getAllVariants().size() > 1) {
                lavcOptionDisplayer lod = new lavcOptionDisplayer(opt);
                add(lod);
                allPanels.add(lod);
            }
        }
    }

    void updateAllDisplayers(lavcResultsPool lrp) {
        Map statMap = lrp.getStatisticsMap();
        Iterator it = allPanels.iterator();
        while(it.hasNext()) {
            lavcOptionDisplayer lod = (lavcOptionDisplayer)it.next();
            lod.buildPieChart(statMap);
        }
    }
}
