/* 
 * Copyright (C) 2004 Romain Dolbeau <romain@dolbeau.org>
 *
 *  This file is subject to the terms and conditions of the GNU General Public
 *  License. See the file COPYING in the main directory of this archive for
 *  more details.
 */

package lavcGenetic;

import java.util.*;

class lavcOption_Flag extends lavcOption {
    private List allInstance = new ArrayList();
    private boolean mandatory;
    private String name;

    public String toString() {
        return "Options: " + allInstance;
    }

    String getDescription() {
        return "Flag: " + name;
    }

    static class lavcOptionInstance_Flag extends lavcOptionInstance {
        String name;
        
        lavcOptionInstance_Flag(String n) {
            name = n;
        }
        
        String getLavcOptionString() {
            return name;
        }
    }
    
    lavcOption_Flag(String n, boolean m) {
        mandatory = m;
        name = n;
        
        if (!m) {
            allInstance.add(new lavcOptionInstance_Flag(null));
        }
        
        allInstance.add(new lavcOptionInstance_Flag(name));
    }

    lavcOption_Flag(List n, boolean m) {
        mandatory = m;
        name = (String)n.get(0);
        
        if (!m) {
            allInstance.add(new lavcOptionInstance_Flag(null));
        }
        
        Iterator it = n.iterator();
        while (it.hasNext()) {
            String t = (String)it.next();
            allInstance.add(new lavcOptionInstance_Flag(t));
        }
    }
    
    java.util.List getAllVariants() {
        return Collections.unmodifiableList(allInstance);
    }

}
