/* 
 * Copyright (C) 2004 Romain Dolbeau <romain@dolbeau.org>
 *
 *  This file is subject to the terms and conditions of the GNU General Public
 *  License. See the file COPYING in the main directory of this archive for
 *  more details.
 */

package lavcGenetic;

import java.util.*;

class lavcOption_Float extends lavcOption {
    private List allInstance = new ArrayList();
    private boolean mandatory;
    private List names;

    public String toString() {
        return("Options: " + allInstance);
    }

    String getDescription() {
        return "Float: " + names;
    }

    static class lavcOptionInstance_Float extends lavcOptionInstance {
        float value;
        List names;
        
        lavcOptionInstance_Float(List n, float i) {
            names = n;
            value = i;
        }
        
        String getLavcOptionString() {
            Iterator it = names.iterator();
            String temp = null;
            while (it.hasNext()) {
                String name = (String)it.next();
                if (temp == null)
                    temp = name + "=" + value;
                else
                    temp = temp + ":" + name + "=" + value;
            }
            return temp;
        }
    }

    lavcOption_Float(String n, List values, boolean m) {
        List temp1 = new ArrayList();
        temp1.add(n);
        init(temp1, values, m);
    }

    lavcOption_Float(List n, List values, boolean m) {
        init(n, values, m);
    }

    private void init(List n, List values, boolean m) {
        mandatory = m;
        names = new ArrayList(n);

        if (!m) {
            allInstance.add(new lavcOptionInstance() {
                    String getLavcOptionString() {
                        return null;
                    }
                });
        }
        
        Iterator it = values.iterator();
        while (it.hasNext()) {
            Object o = it.next();
            if (o instanceof Float) {
                allInstance.add(new lavcOptionInstance_Float(names, ((Float)o).floatValue()));
            } else {
                lavcGeneticMain.err_println("Not Float: " + o);
            }
        }
    }
    
    
    java.util.List getAllVariants() {
        return Collections.unmodifiableList(allInstance);
    }

}
