/* 
 * Copyright (C) 2004 Romain Dolbeau <romain@dolbeau.org>
 *
 *  This file is subject to the terms and conditions of the GNU General Public
 *  License. See the file COPYING in the main directory of this archive for
 *  more details.
 */

package lavcGenetic;

class lavcResults implements Comparable, java.io.Serializable {
    double psnrY, psnrCb, psnrCr, psnrAll;
    double seconds;

    public String toString() {
        return "PSNR: " +
            "Y=" + psnrY + ", " +
            "Cb=" + psnrCb + ", " +
            "Cr=" + psnrCr + ", " +
            "All=" + psnrAll + " " +
            " in " + seconds + " seconds";
            
    }

    lavcResults(double y, double cb, double cr, double all, double s) {
        psnrY = y;
        psnrCb = cb;
        psnrCr = cr;
        psnrAll = all;
        seconds = s;
    }

    boolean isValid() {
        return
            ((psnrY > -1.) &&
             (psnrCb > -1.) &&
             (psnrCr > -1.) &&
             (psnrAll > -1.) &&
             (seconds > -1.));
    }

    public int compareTo(Object o) {
        lavcResults o2 = (lavcResults)o;

        if (psnrAll < o2.psnrAll)
            return -1;
        if (psnrAll > o2.psnrAll)
            return 1;
        if (psnrY < o2.psnrY)
            return -1;
        if (psnrY > o2.psnrY)
            return 1;
        if (psnrCb < o2.psnrCb)
            return -1;
        if (psnrCb > o2.psnrCb)
            return 1;
        if (psnrCr < o2.psnrCr)
            return -1;
        if (psnrCr > o2.psnrCr)
            return 1;
        if (seconds < o2.seconds)
            return -1;
        if (seconds > o2.seconds)
            return 1;
        return 0;
    }

    public boolean equals(Object o) {
        if (o instanceof lavcResults)
            return compareTo(o) == 0;
        return false;
    }
}
